package calc;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Hashtable;
import java.util.Stack;
import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class command{
	private String[] words = new String[] {"exit", "if", "else", "while", "for", "break", "continue","return", "include", "proper", "improper", "round"};
	private String expr = new String("[A-Za-z0-9()*+._/\\-^<>=,]");
	private String VARS = new String("[A-Za-z]{1}[A-Za-z0-9]*");
	private String FileName = new String("[A-Za-z0-9_+$!@#]");
	private StringBuffer resultTEXT = new StringBuffer("result");
	private int BREAK;
	/* the buffer for input*/
	private char[] buf  = new char[80];
	/* the buffer for a command */
	private char[] com  = new char[80];
	/* it is long buffers of input */
	private int buf_length;
	/* it is long commands */
	private int com_length;
	/* a position in the buffer */ 
	private int buf_pos;
	/* a position in a command */
	private int com_pos;
	/* quantity of symbols in a syntactic word */ 
	private int word;
	/* an index of a processable command */
	private int n_command;
	/* an operating mode */
	private int condit;
	/* an operating mode */
	private String[] parametrsV = new String[5];
	/* the container of commands */
	private Vector<String> list_com = new Vector<String>();
	/* the container for calls of functions */
	private Stack<record_run> Runs = new Stack<record_run>();
	/* the container of operating structures */
	private Stack<code> codes = new Stack<code>();
	/* a name of the caused function */
	private StringBuffer name_func = new StringBuffer();
	/* number of a command with a condition equal False */
	private boolean RunsStack;
	private boolean endline;
	private int miss_of_line;
	private fraction lex_fract;
	private StringBuffer lex_vars = new StringBuffer();
	private StringBuffer temp = new StringBuffer();
	/* the container for tracking blocks */
	public Stack<Integer> set_blok = new Stack<Integer>();
	/* the container of variables */
	public Hashtable<String, fraction> m_vars = new Hashtable<String, fraction>();
	/* the list of functions */
	public Hashtable<String, function> functions = new Hashtable<String, function>();
	/* a stack of parameters of function */
	public Stack<fraction> param = new Stack<fraction>();
	private Compiler compiler = new Compiler(m_vars, param);
	/* to not do calculation */
	public boolean miss;
	private boolean COUT;
	public command(){
		BREAK = 0;
		miss = false;
		miss_of_line = -1;
		buf_length = buf_pos = com_length = com_pos = 0;
		n_command = word = 0;	
		condit = Const.CALCULATIONS;
		RunsStack = false;
		m_vars.put(new String("ans"), new fraction(0,1));
		function new_func = new function(null, 0, null, 0, 0);
		functions.put(new String("integer"), new_func);
		functions.put(new String("numerator"), new_func);
		functions.put(new String("denominator"), new_func);
	}
	public void Clear(){
		buf_length = buf_pos = com_length = com_pos = 0;
		BREAK = word = 0;
		miss = false;		
		miss_of_line = -1;
		list_com.clear();
		n_command = 0;
	}
	public boolean is_symbol_vars(char x, boolean first){// = false
		boolean res =(('A' <= x && x <= 'Z') ||
					('a' <= x && x <= 'z') ||
					(x == '_'));
		if (!first && !res)
			res = ('0' <= x && x <= '9');
		return res;
	}
	boolean is_word(String x){
		int count = words.length;
		for (int i = 0; i < count; ++i)
			if (words[i].equals(x))
				return true;
		return false;
	}
	public int condition(){return condit;}
	
	public String global(StringBuffer x){
		if(x.charAt(0) == '0'){
			int pos = x.length()-1;
			while (x.charAt(pos) != '~') --pos;
			x = x.delete(0,pos);
		}
		return x.toString();
	}

	public fraction get_fract(){
		return lex_fract;
	}

	public String get_vars(){
		return lex_vars.toString();
	}

	public int addLine(String buf, int index){
		String x = new String(buf);
		int x_len = x.length();
		int x_pos = 0;
		while (x_pos <  x_len){
			int pos = 0;
			for (int i = 0; i < 80; ++i) com[i] = 0;
			boolean is_simbol = false;
			while (x_pos <  x_len){
				if (x.charAt(x_pos) == '#')
					while (!(x.charAt(x_pos) != '\n' && x.charAt(x_pos) != 0x0A))
						++x_pos;
				if (x.charAt(x_pos) == '/' && x.charAt(x_pos+1) == '*'){
					++x_pos;
					while(!(x.charAt(x_pos-1) == '*' && x.charAt(x_pos) == '/'))
						++x_pos;
					++x_pos;
				}
				// ...
				com[pos] = x.charAt(x_pos);
				++x_pos;
				if (com[pos] == 0x0A) {com[pos] = '\n'; break;}
				if (com[pos] == '\n') break;
				if (com[pos] == '{'){com[pos+1] = '\n';com[pos+2] = 0;break;}
				if (com[pos] == ';'){com[pos+1] = '\n';com[pos+2] = 0;break;}
				if (com[pos] == '}'){
					if (is_simbol){
						com[pos] = '\n';com[pos+1] = 0;--x_pos;
					} else {
						com[pos+1] = '\n';com[pos+2] = 0;
					}
					break;
				}
				if (com[pos] != ' ' && com[pos] != '\t') is_simbol = true;
				++pos;	
			}
			while (com[pos] != 0) ++pos;
			if (com[0] != '\n'){
				if (index < 0)
					list_com.add(new String(com, 0, pos));
				else
					list_com.add(index++, new String(com, 0, pos));
			}
		}
		return index;
	}
	public void ShowListing(){
		System.out.print("\n=====");
		for (int i = 0; i < list_com.size(); ++i)
			System.out.print("\n > " + list_com.get(i).toString());
		System.out.print("\n=====");
	}
	public String Run(){
		resultTEXT.delete(0, resultTEXT.length());
		while (n_command < list_com.size()){
			if (n_command < 0){
				n_command = Runs.peek().from;
				RunsStack = true;
			}
			if (list_com.get(n_command).equals("error\n"))
				++n_command;
			exist();
		}
		return resultTEXT.toString();
	}
	public void exist(){
		StringBuffer current = new StringBuffer();
		StringBuffer from = new StringBuffer(list_com.elementAt(n_command));
		if (RunsStack == true){
			from = new StringBuffer(Runs.peek().command + "\n");
			Runs.pop();
			if (!Runs.empty())
					condit = Const.CALCULATIONS;
			RunsStack = false;
		}
		int length = from.length();
		for(int i = 0; i < length; ++i){
			if (from.charAt(i) == ' ') continue;
			if (from.charAt(i) == '\t') continue;
			if (from.charAt(i) == '/' && from.charAt(i+1) == '*'){
				++i;
				while(!(from.charAt(i) == '*' && from.charAt(i+1) == '/'))
					++i;
				++i;
				continue;
			}			
				current.append(from.charAt(i));
		}
		if (resultTEXT.length() > 0 && resultTEXT.charAt(resultTEXT.length()-1) == '\n')
			resultTEXT.deleteCharAt(resultTEXT.length()-1);
		boolean loop = true;
		Matcher matcher;
		while(loop){
			matcher = Pattern.compile("^exit[;]?\\n$").matcher(current);
			if (matcher.find()){
				System.exit(0);
				loop = false; break;
			}
			matcher = Pattern.compile("^include(" + FileName + "*)\\n$").matcher(current);
			if (matcher.find()){
				list_com.remove(n_command);
				String file = new String(matcher.group(1));
				try {
					FileInputStream fis = new FileInputStream(file);
					File fileinfo = new File(file);
					int file_size = (int) fileinfo.length();
					byte[] buffer = new byte[file_size];
					fis.read(buffer, 0, file_size);
					addLine(new String(buffer) + "\n", n_command);
					fis.close();
				} catch (FileNotFoundException e) {
					e.printStackTrace();
				} catch (IOException e) {
					e.printStackTrace();
				}
				loop = false; break;
			}
			matcher = Pattern.compile("^proper\\n$").matcher(current); 
			if (matcher.find()){
				fraction.proper = Const.PROPER;
				++n_command;
				loop = false; break;
			}
			matcher = Pattern.compile("^improper\\n$").matcher(current);
			if (matcher.find()){
				fraction.proper = Const.IMPROPER;
				++n_command;
				loop = false; break;
			}
			matcher = Pattern.compile("^round[ ]*("+expr+"*)\\n$").matcher(current);
			if (matcher.find()){
				fraction.proper = Const.ROUND;
				++n_command;
				if (!matcher.group(1).equals(""))
					fraction.round = new fraction(new bigNumber(matcher.group(1)), bigNumber.one);
				else 
					fraction.round = new fraction(new bigNumber(5), bigNumber.one);
				loop = false; break;
			}
			matcher = Pattern.compile("^return("+expr+"*)[;]?\\n$").matcher(current);
			if (matcher.find()){
				COUT = find_expr(Const.CODE_EXP, 0);
				 if (condition() == Const.CALCULATIONS)
						error_line("Only in function");
					else 
						if (!miss)
							if (!COUT)
								if (!matcher.group(1).equals("")){
									compiler.compile(matcher.group(1), !miss);
									return_func(compiler.GetResult());
								} else
									return_func(fraction.zer);
				 ++n_command;
				loop = false; break;
			}
			matcher = Pattern.compile("^break;\\n$").matcher(current);
			if (matcher.find()){
				COUT = find_expr(Const.CODE_EXP, 0);
				if (!miss)
					if (!COUT){
						find_break();
					}
				++n_command;				
				loop = false; break;
			}
			matcher = Pattern.compile("^continue;\\n$").matcher(current);
			if (matcher.find()){
				COUT = find_expr(Const.CODE_EXP, 0);
				if (!miss)
					if (!COUT)
						find_continue();
				++n_command;
				loop = false; break;
			}
			matcher = Pattern.compile("^\\{[ ]*\\n$").matcher(current);
			if (matcher.find()){
				blok_open();
				++n_command;
				loop = false; break;
			}
			matcher = Pattern.compile("^\\}[ ]*\\n$").matcher(current);
			if (matcher.find()){
				blok_close();
				++n_command;
				loop = false; break;
			}
			matcher = Pattern.compile("^for\\(("+expr+"*);("+expr+"*);("+expr+"*)\\)(.*)\\n$").matcher(current);
			if (matcher.find()){
				compiler.compile(matcher.group(1), !miss);
				compiler.compile(matcher.group(3), !miss);
				compiler.compile(matcher.group(2), !miss);
				find_for(compiler.GetResult()); //----------------------
				if (!matcher.group(4).equals("")){
					current = new StringBuffer(matcher.group(4) +  "\n");
					continue;
				} else
					++n_command;
				loop = false; break;
			}
			matcher = Pattern.compile("^for\\(("+expr+"*);\\n$").matcher(current);
			if (matcher.find()){
				find_for_small();
				compiler.compile(matcher.group(1), !miss);
				++n_command;
				loop = false; break;
			}
			matcher = Pattern.compile("^if\\(("+expr+"*)\\)(.*)\\n$").matcher(current);
			if (matcher.find()){
				compiler.compile(matcher.group(1), !miss);
				find_if(compiler.GetResult(), 0);
				if (!matcher.group(2).equals("")){
					current = new StringBuffer(matcher.group(2) +  "\n");
					continue;
				} else
					++n_command;
				loop = false; break;
			}
			matcher = Pattern.compile("^while\\(("+expr+"*)\\)(.*)\\n$").matcher(current);
			if (matcher.find()){
				boolean blok = !matcher.group(2).equals("");
				compiler.compile(matcher.group(1), !miss);
				find_while(compiler.GetResult(), 0);
				if (blok){
					current = new StringBuffer(matcher.group(2) +  "\n");
					continue;
				} else
					++n_command;
				loop = false; break;
			}
			matcher = Pattern.compile("^else(.*)\\n$").matcher(current);
			if (matcher.find()){
				find_else(0);	
				if (!matcher.group(1).equals("")){
					current = new StringBuffer(matcher.group(1) +  "\n");
					continue;
				} else
					++n_command;
				loop = false; break;
			}
			matcher = Pattern.compile("^("+VARS+")\\(("+expr+"*)\\)\\{\\n$").matcher(current);
			if (matcher.find()){
				if (condition() != Const.CALCULATIONS)
					error_line("Embedded functions not possible");
				else 
					open_func(matcher.group(1));
				loop = false; break;
			}
			matcher = Pattern.compile("^("+expr+"*){1}[;]?\\n$").matcher(current);
			if (matcher.find()){
				++n_command;
				COUT = find_expr(Const.CODE_EXP, 0);
				compiler.compile(current.toString(), !miss);
				if (compiler.isRun()){
					run_func( new String(compiler.GetFuncton()));
				} else {
					String result = new String(compiler.GetResult().toString());
					if (!miss)
						if (!COUT && condition() !=  Const.DESCRIPTION_FUNCTION)
							if (current.indexOf(";") < 0)
								resultTEXT.append("\n> " + result);				
				}
				loop = false; break;
			}
			if (loop){
				resultTEXT.append("\nError: *" + current + "*");
				++n_command;
				loop = false; break;
			}
		}
	}
/*				if (condit == Const.EXECUTION_FUNCTION && name_var.charAt(0) != '~')
					name_var.append("0~" + Runs.peek().name + "~" + name_var);
				if (condit == Const.DESCRIPTION_FUNCTION && name_var.charAt(0) != '~')
					name_var.append("0~" + name_func + "~" + name_var);
*/
	private void open_func(String name){
		condit = Const.DESCRIPTION_FUNCTION;
		StringBuffer str = new StringBuffer();
		int temp_nom_command = n_command+1;
		int temp_pos = 0;
		int nom_param = 0;
		while (list_com.elementAt(temp_nom_command-1).charAt(temp_pos++) != '(');
		while (list_com.elementAt(temp_nom_command-1).charAt(temp_pos) != ')'){
			if (str.length() > 0)
				str.delete(0, str.length()-1);
			while (list_com.elementAt(temp_nom_command-1).charAt(temp_pos) != ',' &&	list_com.elementAt(temp_nom_command-1).charAt(temp_pos) != ')'){
				if (is_symbol_vars(list_com.elementAt(temp_nom_command-1).charAt(temp_pos),false))
					str.append(list_com.elementAt(temp_nom_command-1).charAt(temp_pos));
				++temp_pos;
			}
			if(list_com.elementAt(temp_nom_command-1).charAt(temp_pos) == ',')
				++temp_pos;
			parametrsV[nom_param] = new String(str);
			++nom_param;					
		}
		functions.put(name, new function(name, nom_param, parametrsV, n_command, 0));
		if(name_func.length() > 0)
			name_func.delete(0, name_func.length()-1);
		name_func.append(name);
		s_blok();
	}	
	private void run_func(String name){
		--n_command;
		record_run temp = new record_run();
		temp.name = new String(name);
		temp.from = n_command;
		temp.command = new String(list_com.elementAt(n_command));
		temp.codes_size = codes.size();
		temp.blok_size = set_blok.size();
		if (temp.codes_size > 0)
			temp.code_cond = codes.peek();
		int end_pos = temp.command.length()-1;
		while (temp.command.charAt(end_pos) != ')') --end_pos;
		int count_param = 1;
		int count_sk = 0;
		int exit = 1;
		while (count_sk + exit > 0){
			exit = 0;
			if (temp.command.charAt(end_pos) == ')') ++count_sk;
			if (temp.command.charAt(end_pos) == '(') --count_sk;
			if (temp.command.charAt(end_pos) == ',') ++count_param;
			--end_pos;
		}
		temp.pos_name = end_pos;
		Runs.push(temp);
		while(count_param > functions.get(name).count_par){
			--count_param;
			param.pop();
		}
		if (count_param < functions.get(name).count_par){
			int i = functions.get(name).count_par;
			while(i > count_param){		
				m_vars.put(functions.get(name).par[--i], new fraction(fraction.zer));
			}
		}
		for(int i = count_param-1; i+1 > 0; --i){
			m_vars.put(functions.get(name).par[i], new fraction(param.pop()));
		}
		n_command = functions.get(name).begin+1;
		condit = Const.EXECUTION_FUNCTION;
	}
	private void return_func(fraction res){
		/* at CALCULATION there is no this event */
		/* at DEF_FUNCTION there is no this event */
		if (condit == Const.EXECUTION_FUNCTION){
			int pos_end = Runs.peek().pos_name;
			int pos = pos_end - Runs.peek().name.length()+2;		
			int count_skob = 0;
			int exit = 1;
			while (count_skob+exit > 0){
				exit = 0;
				++pos_end;
				if (Runs.peek().command.charAt(pos_end) == '(') ++count_skob;
				if (Runs.peek().command.charAt(pos_end) == ')') --count_skob;			
			}
			Runs.peek().command = Runs.peek().command.substring(0, --pos) + res.toString() +		 
				Runs.peek().command.substring(++pos_end, Runs.peek().command.length()-1);
			n_command = -2;
			while(codes.size() > 0 && codes.size() >= Runs.peek().codes_size)
					codes.pop();
			if (Runs.peek().codes_size > 0)
				codes.push(Runs.peek().code_cond);
			while (Runs.peek().blok_size < set_blok.size())
				set_blok.pop();
			compiler.SetAVars(null);
		}
	}
	private void find_break(){
		int size_st = 0;
		if (Runs.size() > 0){
			//  
			int size_codes = codes.size();
			while(size_codes > 0 && size_codes >= Runs.peek().codes_size){
				if (codes.elementAt(codes.size() - size_codes).name == Const.CODE_US_WHILE){
					miss = true;
					miss_of_line = size_codes;
					break;
				} else
					--size_codes;
			}
		} else {
			//   
			int size_codes = codes.size();
			while(size_codes > 0){
				if (codes.elementAt(size_codes-1).name == Const.CODE_US_WHILE){
					miss = true;
					miss_of_line = size_codes-1;
					break;
				} else
					--size_codes;
			}
		}
	}
	private void find_continue(){
		int size_st = 0;
		int command_line = 0;
		if (Runs.size() > 0){
			//  
			int size_codes = codes.size();
			while(size_codes > 0 && size_codes >= Runs.peek().codes_size){
				if (codes.elementAt(codes.size() - size_codes).name == Const.CODE_US_WHILE){
					miss = false;
					miss_of_line = size_codes;
					command_line = codes.elementAt(codes.size() - size_codes).line;
					break;
				} else {
					codes.pop();			
					--size_codes;
				}
			}
		} else {
			//   
			int size_codes = codes.size();
			while(size_codes > 0){
				if (codes.elementAt(codes.size() - size_codes).name == Const.CODE_US_WHILE){
					miss = false;
					miss_of_line = size_codes;
					command_line = codes.elementAt(codes.size() - size_codes).line;
					break;
				} else {
					codes.pop();
					--size_codes;
				}
			}
		}
		n_command = command_line-1;		
	}
	private void find_if(fraction res, int type){
		find_expr(Const.CODE_US_IF,type);
		if (condit == Const.DESCRIPTION_FUNCTION) res.SetValue(fraction.zer);
		if (res.eq(fraction.zer) && miss == false){
			miss = true;
			miss_of_line = codes.size();
		}
	}
	private void find_else(int type){
		find_expr(Const.CODE_US_ELSE,type);
	}
	private void find_while(fraction res,int type){
		find_expr(Const.CODE_US_WHILE,type);	
		if (condit == Const.DESCRIPTION_FUNCTION) res.SetValue(fraction.zer);
		if (res.eq(fraction.zer)){
			miss = true;
			miss_of_line = codes.size();
		}
	}
	private void find_for_small(){
		StringBuffer temp = new StringBuffer(list_com.elementAt(n_command));
		temp.deleteCharAt(temp.length() - 1);
		temp.append(' ' + list_com.elementAt(n_command+1));
		temp.deleteCharAt(temp.length() - 1);
		temp.append(' ' + list_com.elementAt(n_command+2));

		int pos_b = 0, pos_e = 0;	
		while(temp.charAt(pos_b) != '(') ++pos_b;
		pos_e = pos_b;
		while(temp.charAt(pos_e) != ';') ++pos_e;
		String a = new String(temp.substring(pos_b+1,pos_e));
		pos_b = pos_e++;
		while(temp.charAt(pos_e) != ';') ++pos_e;
		String b = new String(temp.substring(pos_b+1,pos_e));
		pos_b = pos_e;
		int count_skb = 0;
		while (pos_e < temp.length()){
			if (temp.charAt(pos_e) == '(') ++count_skb;
			if (temp.charAt(pos_e) == ')') --count_skb;
			if (temp.charAt(pos_e) == ')' && count_skb == -1)
				break;
			++pos_e;
		}
		String c = new String(temp.substring(pos_b+1,pos_e));
		String d = new String(temp.substring(pos_e+1, (int) temp.length()-1));
		//==========================//
		list_com.remove(n_command);
		list_com.remove(n_command);
		list_com.set(n_command, new String("for (" + a + ";" + b + ";5/*" + c + "*/)" + d + "\n"));
		//=========================//
		--n_command;
	}
	private void find_for(fraction res){
		find_expr(Const.CODE_US_WHILE,0);	
		if (condit == Const.DESCRIPTION_FUNCTION) res.SetValue(fraction.zer);
		if (res.eq(fraction.zer)){
			miss = true;
			miss_of_line = codes.size();
		}
		char[] buffer = new char[100];
		int i = 0, j = 0;
		for (; i < list_com.elementAt(n_command).length(); ++i, ++j){
			if (list_com.elementAt(n_command).charAt(i) == '/' && list_com.elementAt(n_command).charAt(i+1) == '*'){
				j-=2;
				i+=1;
			
			} else
			if (list_com.elementAt(n_command).charAt(i) == '*' && list_com.elementAt(n_command).charAt(i+1) == '/'){
				j-=1;	
				i+=1;	
			} else
			buffer[j] = list_com.elementAt(n_command).charAt(i);
		}
		buffer[j] = 0;
		StringBuffer temp = new StringBuffer();
		temp.append(buffer, 0, j);
		int pos_b = 0, pos_e = 0;	
		while(temp.charAt(pos_b) != '(') ++pos_b;
		pos_e = pos_b;
		while(temp.charAt(pos_e) != ';') ++pos_e;
		String a = new String(temp.substring(pos_b+1,pos_e));
		pos_b = pos_e++;
		while(temp.charAt(pos_e) != ';') ++pos_e;
		String b = new String(temp.substring(pos_b+1,pos_e));
		pos_b = pos_e;
		int count_skb = 0;
		while (pos_e < temp.length()){
			if (temp.charAt(pos_e) == '(') ++count_skb;
			if (temp.charAt(pos_e) == ')') --count_skb;
			if (temp.charAt(pos_e) == ')' && count_skb == -1)
				break;
			++pos_e;
		}
		String c = new String(temp.substring(pos_b+1,pos_e));
		String d = new String(temp.substring(pos_e+1, (int) temp.length()-1));
		if (res.eq(fraction.zer)){
			list_com.set(n_command,new String("for (" + a + ";" +b + ";5/*" + c + "*/)" + d + "\n"));
		} else {
			list_com.set(n_command,new String("for (5/*" + a + "*/;"  + b + ";" + c + ")" + d + "\n"));
		}
	}

	private boolean codes_pop(int code, boolean from_else, boolean from_end){
		boolean res = false;
		if (!codes.empty()){
			if (code == Const.CODE_EXP) res = (codes.peek().cond == code);
			if (code == Const.CODE_BLC) res = (codes.peek().cond == code);
			if (code == 0) res = ((codes.peek().cond == Const.CODE_EXP) || codes.peek().cond == Const.CODE_BLC);
		}
		if (!codes.empty() && res){
			if (codes.peek().name == Const.CODE_US_IF && from_end) return false;
			if (codes.peek().name == Const.CODE_US_IF){
				if (from_else){
					if(miss == true){
						if (miss_of_line == codes.size()){
							miss = false; miss_of_line = -1;
						} 
					} else {
						miss = true; miss_of_line = codes.size();
					}	
				} else {
					if(miss == true && miss_of_line == codes.size()){
						miss = false; miss_of_line = -1;
					}
				}
				codes.pop();
				return true;
			}
			if (codes.peek().name == Const.CODE_US_WHILE){
				if (miss == false){
						if (codes.peek().cond == Const.CODE_EXP)
							n_command = codes.peek().line;
						else
							n_command = codes.peek().line-1;
					codes.pop();
					if (!codes.empty() && codes.peek().cond == Const.CODE_EXP)
						codes.peek().cond = Const.CODE_NUL;
				} else {
					if (miss_of_line == codes.size()){
						miss = false; miss_of_line = -1;
					}					
					codes.pop();
				}
				return true;
			}
			if (codes.peek().name == Const.CODE_US_ELSE){
				if(miss == true && miss_of_line == codes.size()){
					miss = false; miss_of_line = -1;
				}
				codes.pop();
				return true;
			}	
		}
		return false;
	}

	boolean find_expr(int why, int blok){
		boolean res = false;
		if (why == Const.CODE_US_IF || why == Const.CODE_US_WHILE){
			if (!codes.empty() && codes.peek().cond == Const.CODE_NUL && codes.peek().name != Const.CODE_US_BLOK)
				codes.peek().cond = Const.CODE_EXP;
			else
				codes_pop(0,false,false);
			codes.push(new code(why, Const.CODE_NUL, n_command+blok));
		}
		if (why == Const.CODE_US_ELSE){
			if (codes_pop(0,true,false)){
				codes.push(new code(Const.CODE_US_ELSE, Const.CODE_NUL, n_command));
			}
			else
				error_line("The 'if' in not found");
		}
		if (why == Const.CODE_BLO){
			if (!codes.empty() && codes.peek().cond == Const.CODE_NUL && codes.peek().name != Const.CODE_US_BLOK){
				codes.peek().cond = Const.CODE_BLO;
				return false;
			}
			if (codes_pop(0,false,false)){
				while(codes_pop(0,false,false));
				return false;
			}
			codes.push(new code(Const.CODE_US_BLOK, Const.CODE_NUL, n_command));
		}
		if (why == Const.CODE_BLC){
			while(codes_pop(0,false,false));
			if (!codes.empty() && codes.peek().name == Const.CODE_US_BLOK){
				codes.pop();
				return false;
			}
			if (!codes.empty() && codes.peek().cond == Const.CODE_NUL)
				error_line("The opening curly braces is not found");
			if (!codes.empty() && codes.peek().cond == Const.CODE_BLO)
				codes.peek().cond = Const.CODE_BLC;
		}
		if (why == Const.CODE_EXP){
			while(codes_pop(0,false,false));			
			if (!codes.empty() && codes.peek().cond == Const.CODE_NUL && codes.peek().name != Const.CODE_US_BLOK){
				codes.peek().cond = Const.CODE_EXP;
				if (miss == true && (codes.peek().name == Const.CODE_US_WHILE || codes.peek().name == Const.CODE_US_ELSE))
					res = true;
			}
		}
		while(codes_pop(0,false,true));
		return res;
	}
	void blok_open(){
		find_expr(Const.CODE_BLO, 0);
		set_blok.push(n_command);
	}
	void s_blok(){
		StringBuffer Temp = new StringBuffer(list_com.elementAt(n_command));
		Temp.deleteCharAt(Temp.length()-2);
		list_com.set(n_command, new String(Temp.toString()));
		temp = new StringBuffer("{\n");
		list_com.add(n_command+1, "{\n");
		++n_command;
	}
	void blok_close(){
		if (set_blok.empty())
			error_line("The opening curly braces is not found");
		else {
			find_expr(Const.CODE_BLC, 0);
			set_blok.pop();
			if (set_blok.empty() && condit == Const.DESCRIPTION_FUNCTION)
				condit = Const.CALCULATIONS;
		}
	}
	private void error_line(String x){
		System.out.print("*** Error");
		if (x != null) System.out.print(" : " + x); 
		System.out.print("!\n");
		list_com.set(n_command, new String("error\n"));
		com_length = com_pos;
		++n_command;
	}

	private void find_exit(){
		System.out.print("bay!");
		System.exit(0);
	}
}
