package calc;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.File;
import java.util.Vector;

import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTree;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.tree.DefaultMutableTreeNode;

class myTabbed extends JTabbedPane{
	private Vector<Project> projects = new Vector<Project>();
	private DefaultMutableTreeNode root;
	private JTextArea output;
	private JTree tree;
	
	public myTabbed(int x, int y, JTextArea _output, DefaultMutableTreeNode _root, JTree _tree){
		super(x,y);
		root = _root;
		tree = _tree;
		output = _output;
		addKeyListener(new event());
	}
	private void out_var_fun(){
		root.removeAllChildren();
		root.add(projects.get(getSelectedIndex()).getVarTree());
		root.add(projects.get(getSelectedIndex()).getFunTree());
		tree.repaint();
	}
	public void add(){
		Project temp = new Project();
		add("untitled", temp);
		projects.add(temp);
		setSelectedIndex(getTabCount()-1);
	}
	public void Addline(String x){
		projects.get(getSelectedIndex()).Addline(x);
		output.append(projects.get(getSelectedIndex()).Run().toString());
		out_var_fun();
	}
	public void Run(){
		output.setText("");
		if (projects.size() > 0){
			output.append(projects.get(getSelectedIndex()).GlobalRun().toString());
			out_var_fun();
		}
	}
	public void Help(){
		Project temp = new Project();
		temp.Help();
		add("Help", temp);
		projects.add(temp);
		setSelectedIndex(getTabCount()-1);
	}
	public void LoadFile(File file){
		Project temp = new Project();
		temp.LoadFile(file);
		add(temp.getLabel(), temp);
		projects.add(temp);
		setSelectedIndex(getTabCount()-1);
	}
	public void SaveFile(File file){
		projects.get(getSelectedIndex()).SaveFile(file);
		setTitleAt(getSelectedIndex(), projects.get(getSelectedIndex()).getLabel());
	}
	public void Close(){
		if (getTabCount() > 0){
			projects.remove(getSelectedIndex());
			remove(getSelectedIndex());
		}
	}
	public boolean isSave(){
		if (getTabCount() == 0)
			return true;
		return projects.get(getSelectedIndex()).isSaved();		
	}
	public boolean isPath(){
		if (getTabCount() == 0)
			return true;
		return projects.get(getSelectedIndex()).isPath();
	}
	class event implements KeyListener{
		public void keyPressed(KeyEvent e) {
			if (e.getKeyCode() == KeyEvent.VK_F5)
				Run();
		}
		public void keyReleased(KeyEvent e) {}
		public void keyTyped(KeyEvent e) {}	
	}
}