package calc;

import java.util.Vector;

public class bigNumber{
	private Vector<Int_char> number;
	private int sign;
	private int b;
	public static bigNumber zer = new bigNumber(0);
	public static bigNumber one = new bigNumber(1);
		
	private int comparison(bigNumber x){
		if (number.size() < x.number.size())
			return -1;
		if (number.size() > x.number.size())
			return 1;
		for (int i = 0; i < number.size(); ++i){
			if (number.elementAt(i).equals(x.number.elementAt(i)) == -1)
				return -1;
			if (number.elementAt(i).equals(x.number.elementAt(i)) == 1)
				return 1;
		}
		return 0;	
	}
	public bigNumber(){
		number = new Vector<Int_char>();
		sign = 1;
		number.add(new Int_char(0));
	};
	public bigNumber(String x){
		number = new Vector<Int_char>();
		b = 0;
		int i = 0;
		if (x.charAt(0) == '-') {
			sign = -1;
			++i;
		} else 
			sign = 1;
		if (x.charAt(0) == '+') ++i;
		int len = x.length();
		for (; i < len; ++i){
			b = (x.charAt(i)-'0');
			number.addElement(new Int_char(b));	
		}
	}
	public bigNumber(int x){
		number = new Vector<Int_char>();
		b = 0;
		sign = (x >=0) ? 1 : -1;
		x = (x > 0) ? x : -x;
		if (x == 0)
			number.add(0,new Int_char(b));
		else {
			while(x > 0){
				b = (x%10);
				number.add(0,new Int_char(b));
				x /= 10;
			}
		}
	}
	public bigNumber(bigNumber dst){
		sign = dst.sign;
		number = new Vector<Int_char>();
		for(int i=0; i < dst.number.size(); ++i)
			number.add(new Int_char(dst.number.elementAt(i).GetValue()));
	}
	public void setABS(){
		sign = 1;
	}
	public bigNumber un_minus(){
		bigNumber result = new bigNumber(this);
		result.sign *= -1;
		return result;
	}
	public int length(){
		return number.size();
	}
	public boolean is_negative(){ 
		return (sign==-1);
	}
	public void set_power_of_ten(int x){
		number.clear();
		sign = 1;
		number.add(0, new Int_char(1));
		while(--x+1 > 0)
			number.add(new Int_char(0));	
	}
	public boolean is_even(){
		return !(number.elementAt(0).GetValue() == 1);
	}
	public bigNumber SetValue(bigNumber dst){
		sign = dst.sign;
		number.clear();
		for(int i=0; i < dst.number.size(); ++i)
			number.add(new Int_char(dst.number.elementAt(i).GetValue()));
		return this;
	}
	public bigNumber Add(bigNumber obj){
		if ((sign == -1) && (obj.sign == 1)) {
			bigNumber left = new bigNumber(this);
			left.sign = 1;
			return obj.minus(left);
		}
		if ((sign == 1) && (obj.sign == -1)){
			obj.sign = 1;
			return this.minus(obj);
		}
		bigNumber left, right;
		if (number.size() >= obj.number.size()){
			left = this;
			right = obj;
		} else {
			left = obj;
			right = this;
		}
		bigNumber result = new bigNumber(left);
		char carrying=0;
		int index_left = left.number.size()-1;
		int index_right = right.number.size()-1;
		Int_char buf = new Int_char(0);
		while (index_right+1 > 0 && index_left+1 > 0){
			carrying += left.number.elementAt(index_left).GetValue() + right.number.elementAt(index_right).GetValue();
			result.number.elementAt(index_left).SetValue(carrying % 10);
			carrying /= 10;
			--index_left;
			--index_right;		
		}
		while(carrying > 0 && index_left+1 > 0){
			carrying += result.number.elementAt(index_left).GetValue();
			result.number.elementAt(index_left).SetValue(carrying % 10);
			carrying /= 10;
			--index_left;
		}
		while(carrying > 0){
			buf.SetValue(carrying%10);
			result.number.add(0,buf);
			carrying /= 10;
		}
		return result;
	}
	public bigNumber Inc(){
		int index = number.size()-1;
		int carrying = number.elementAt(index).GetValue() + 1;
		Int_char buf = new Int_char(0);
		number.elementAt(index--).SetValue(carrying % 10);
		carrying /= 10;
		while(carrying > 0 && index+1 > 0){
			carrying += number.elementAt(index).GetValue();
			number.elementAt(index).SetValue(carrying % 10);
			carrying /= 10;
			--index;
		}
		buf.SetValue(carrying%10);
		while(carrying > 0){
			number.add(0,buf);
			carrying /= 10;
		}
		return this;
	}
	public bigNumber Inc_i(){
		bigNumber result = new bigNumber(this);
		char index = (char) (number.size()-1);
		char carrying = (char) (number.elementAt(index).GetValue() + 1);
		Int_char buf = new Int_char((char) 0);
		number.elementAt(index--).SetValue(carrying % 10);
		carrying /= 10;
		while(carrying > 0 && index+1 > 0){
			carrying += number.elementAt(index).GetValue();
			number.elementAt(index).SetValue(carrying % 10);
			carrying /= 10;
			--index;
		}
		while(carrying > 0){
			buf.SetValue(carrying%10);
			number.add(0, buf);
			carrying /= 10;
		}
		return result;
	}
	public bigNumber Dec(){
		int borrow = -1;
		int index = number.size()-1;
		while (index+1 > 0 && borrow == -1){
			if (number.elementAt(index).GetValue() == 0){
				number.elementAt(index).SetValue(9);
				borrow = -1;
			} else {
				number.elementAt(index).SetValue(number.elementAt(index).GetValue()-1);
				borrow = 0;
			}
			--index;
		}
		while(number.elementAt(0).GetValue() == 0 && number.size() > 1) 
			number.remove(0);
		return this;
	}
	public bigNumber Dec_i(){
		bigNumber result = new bigNumber(this);
		int borrow = -1;
		int index = number.size()-1;
		while (index+1 > 0 && borrow == -1){
			if (number.elementAt(index).GetValue() == 0){
				number.elementAt(index).SetValue(9);
				borrow = -1;
			} else {
				number.elementAt(index).SetValue(number.elementAt(index).GetValue()-1);
				borrow = 0;
			}
			--index;
		}
		while(number.elementAt(0).GetValue() == 0 && number.size() > 1) 
			number.remove(0);
		return result;
	}
	public bigNumber minus(bigNumber obj){
		if ((sign == 1) && (obj.sign == -1)){
			obj.sign = 1;
			return this.Add(obj);
		}
		if ((sign == -1) && (obj.sign == -1)){
			obj.sign = 1;
			bigNumber temp = new bigNumber(this);
			temp.sign = 1;
			return obj.minus(temp);
		}
		if ((sign == -1) && (obj.sign == 1)){
			obj.sign = -1;
			return this.Add(obj);
		}
		bigNumber left = this;
		bigNumber right = obj;
		int new_sign = 1;
		if (comparison(obj) == -1){
			left = obj;
			right = this;
			new_sign = -1;
		}
		bigNumber result = new bigNumber(left);	
		result.sign = new_sign;
		int borrow=0;
		int i_byte=0;
		int index_left = left.number.size()-1;
		int index_right = right.number.size()-1;
		while(index_right+1>0 && index_left+1>0){
			i_byte = left.number.elementAt(index_left).GetValue() - right.number.elementAt(index_right).GetValue()+borrow;
			if (i_byte < 0){
				i_byte += 10;
				borrow = -1;
			} else 
				borrow = 0;
			result.number.elementAt(index_left).SetValue(i_byte);
			--index_left;
			--index_right;	
		}
		if (borrow == -1)
			while (index_left+1>0 && borrow == -1){
				if (result.number.elementAt(index_left).GetValue() == 0){
					result.number.elementAt(index_left).SetValue(9);
					borrow = -1;
				} else {
					result.number.elementAt(index_left).SetValue(result.number.elementAt(index_left).GetValue() - 1);
					borrow = 0;
				}
				--index_left;
			}
		while(result.number.elementAt(0).GetValue() == 0 && result.number.size() > 1) 
			result.number.remove(0);
		return result;
	}
	
	public bigNumber Mult(bigNumber obj){
		if (this.number.equals(bigNumber.one.number))
			return obj;
		if (obj.number.equals(bigNumber.one.number))
			return this;
		int w = number.size() + obj.number.size();
		char[] res = new char[w];
		for(int i=0; i < w; ++i) res[i] = '0';
		--w;
		bigNumber result = new bigNumber(new String(res));
		int carrying = 0;
		int buffer = 0;
		int n = number.size()-1;
		int m = obj.number.size()-1;
		for (int i = 0; i < m+1; ++i){
			//if (obj.number[i] == 0) continue;
			for (int j = 0; j < n+1; ++j){
				buffer = number.elementAt(n-j).GetValue()*obj.number.elementAt(m-i).GetValue()+result.number.elementAt(w-i-j).GetValue()+carrying;
				result.number.elementAt(w-i-j).SetValue(buffer % 10);
				carrying = buffer / 10;
			}
			if (carrying > 0){
				result.number.elementAt(w-i-n-1).SetValue(result.number.elementAt(w-i-n-1).GetValue() + carrying);
				carrying = 0;
			}
		}
		while(result.number.elementAt(0).GetValue() == 0 && result.number.size() > 1){ 
			result.number.remove(0);
		}
		result.sign = sign*obj.sign;
		return result;
	}
	public bigNumber Del(bigNumber obj){
		if (obj.eq(bigNumber.one) == true)
			return new bigNumber(this);
		if (this.eq(bigNumber.zer) == true)
			return new bigNumber(bigNumber.zer);
		bigNumber result = new bigNumber();
		char q = 0, r = 0;
		if (this.comparison(obj) < 0){
			result.number.add(0, new Int_char(r));
			return result;
		}
		bigNumber A = new bigNumber(this);
		A.number.add(0, new Int_char(r));
		int d = 10/(obj.number.elementAt(0).GetValue()+1);
		int lenght = 0, carrying = 0, k = 0;
		bigNumber obj_copy = new bigNumber(obj);
		/*  */
		if (d > 1){
			lenght = obj_copy.number.size();
			for(int i = lenght-1; i+1 > 0; --i){
				carrying += obj_copy.number.elementAt(i).GetValue()*d;
				obj_copy.number.elementAt(i).SetValue(carrying % 10);
				carrying /= 10;
			}
			lenght = A.number.size();
			carrying = 0;
			for(int i = lenght-1; i > 0; --i){
				carrying += A.number.elementAt(i).GetValue()*d;
				A.number.elementAt(i).SetValue(carrying % 10);
				carrying /= 10;
			}
			A.number.elementAt(0).SetValue(carrying);
		}
		/*-------no error---------*/
		lenght = A.number.size() - obj_copy.number.size();
		for (int j = 1; j <= lenght; ++j){
			q = (char) ((A.number.elementAt(j-1).GetValue()*10+A.number.elementAt(j).GetValue())/obj_copy.number.elementAt(0).GetValue());
			r = (char) ((A.number.elementAt(j-1).GetValue()*10+A.number.elementAt(j).GetValue())%obj_copy.number.elementAt(0).GetValue());
			while(q > 9){
				--q; 
				r += obj_copy.number.elementAt(0).GetValue();		
			}
			if (j+1 < obj_copy.number.size()){
				if (q*obj_copy.number.elementAt(1).GetValue() > 10*r+A.number.elementAt(j+1).GetValue()){
					--q; 
					r += obj_copy.number.elementAt(0).GetValue();
				}
				if ((r < 10) && (q*obj_copy.number.elementAt(1).GetValue() > 10*r+A.number.elementAt(j+1).GetValue())){
					--q; 
					r += obj_copy.number.elementAt(0).GetValue();
				}
			}
			if (j < 4)
			k = carrying = 0;
			for (int n = obj_copy.number.size()-1; n >= -1; --n){
				if (n+1 > 0)
					carrying += obj_copy.number.elementAt(n).GetValue() * q;
				A.number.elementAt(j+n).SetValue(A.number.elementAt(j+n).GetValue()-(carrying%10)+k);
				k = 0;
				carrying /= 10;
				if (A.number.elementAt(j+n).GetValue() < 0){
					A.number.elementAt(j+n).SetValue(A.number.elementAt(j+n).GetValue() + 10);
					--k;
				}
				A.number.elementAt(j+n).SetValue(A.number.elementAt(j+n).GetValue()%10);
			}
			if (k < 0){
				--q;
				carrying = 0;
				for (int n = obj_copy.number.size()-1; n >= 0; --n){
						carrying += A.number.elementAt(j+n).GetValue()+obj_copy.number.elementAt(n).GetValue();
					A.number.elementAt(j+n).SetValue(carrying % 10);
					carrying /= 10;
				}
				A.number.elementAt(j-1).SetValue((A.number.elementAt(j-1).GetValue() + carrying) % 10);
				k = 0;
			}	
			result.number.add(new Int_char(q));
		}
		while(result.number.elementAt(0).GetValue() == 0 && result.number.size() > 1) 
			result.number.remove(0);
		result.sign = A.sign * obj.sign;
		return result;
	}

	public bigNumber Ost(bigNumber obj){
		if (obj.eq(bigNumber.zer) ==  true)
			return bigNumber.zer;
		char q = 0, r = 0;
		bigNumber A = new bigNumber(this);
		A.number.add(0, new Int_char(r));
		int d = 10/(obj.number.elementAt(0).GetValue()+1);
		int lenght = 0, carrying = 0;
		bigNumber obj_copy = new bigNumber(obj);
		if (d > 1){
			lenght = obj_copy.number.size();
			for(int i = lenght-1; i+1 > 0; --i){
				carrying += obj_copy.number.elementAt(i).GetValue()*d;
				obj_copy.number.elementAt(i).SetValue(carrying % 10);
				carrying /= 10;
			}
			lenght = A.number.size();
			carrying = 0;
			for(int i = lenght-1; i > 0; --i){
				carrying += A.number.elementAt(i).GetValue()*d;
				A.number.elementAt(i).SetValue(carrying % 10);
				carrying /= 10;
			}
			A.number.elementAt(0).SetValue(carrying);
		}
		lenght = A.number.size() - obj_copy.number.size();
		for (int j = 1; j <= lenght; ++j){
			q = (char) ((A.number.elementAt(j-1).GetValue()*10+A.number.elementAt(j).GetValue())/obj_copy.number.elementAt(0).GetValue());
			r = (char) ((A.number.elementAt(j-1).GetValue()*10+A.number.elementAt(j).GetValue())%obj_copy.number.elementAt(0).GetValue());
			if (j+1 < obj_copy.number.size()){
				if (q > 9 || (q*obj_copy.number.elementAt(1).GetValue() > 10*r+A.number.elementAt(j+1).GetValue())){
					--q; 
					r += A.number.elementAt(j+1).GetValue();
				}
				if (q > 9 || (q*obj_copy.number.elementAt(1).GetValue() > 10*r+A.number.elementAt(j+1).GetValue())){
					--q; 
					r += A.number.elementAt(j+1).GetValue();
				}
			} else {
				if (q > 9){
					--q; 
					r += A.number.elementAt(j+1).GetValue();
				}
				if (q > 9){
					--q; 
					r += A.number.elementAt(j+1).GetValue();
				}		
			}
			int k = carrying = 0;
			for (int n = obj_copy.number.size()-1; n+2 > 0; --n){
				if (n+1 > 0)
					carrying += obj_copy.number.elementAt(n).GetValue() * q;
				A.number.elementAt(j+n).SetValue((A.number.elementAt(j+n).GetValue()-(carrying % 10)+k) % 10);
				k = 0;
				carrying /= 10;
				if (A.number.elementAt(j+n).GetValue() < 0){
					A.number.elementAt(j+n).SetValue(A.number.elementAt(j+n).GetValue() + 10);
					--k;
				}
			}
			if (k == -1){
				--q;
				carrying = 0;
				for (int n = obj_copy.number.size()-1; n+2 > 0; --n){
					if (n+1 > 0)
						carrying += A.number.elementAt(j+n).GetValue()+obj_copy.number.elementAt(n).GetValue();
					A.number.elementAt(j+n).SetValue(carrying % 10);
					carrying /= 10;
				}
			}
		}
		while(A.number.elementAt(0).GetValue() == 0 && A.number.size() > 1) 
			A.number.remove(0);
		A.sign = A.sign * obj_copy.sign;
		if (A.number.elementAt(0).GetValue() == 0)
			A.sign = 1;
		return A.Del(new bigNumber(d));
	}
	public bigNumber round(bigNumber x, bigNumber y, bigNumber count){
		char nol = 0;
		bigNumber temp = new bigNumber(count);
		while(temp.comparison(zer) > 0){
			temp.Dec();
			x.number.add(new Int_char(nol));
		}
		return x.Del(y);
	}

	public char elementAt(int i){
		if ((int) i >= number.size())
			i = number.size()-1;
		return (char) number.elementAt(i).GetValue();
	}

	public boolean le(bigNumber obj){
		if (sign == -1 && obj.sign == 1)
			return true;
		if (sign == 1 && obj.sign == -1)
			return false;
		if (sign == -1){
			if (comparison(obj) == -1)
				return false;
			if (comparison(obj) == 1)
				return true;
			for (int n = 0; n < number.size(); ++n){
				if (number.elementAt(n).GetValue() > obj.number.elementAt(n).GetValue())
					return true;
				if (number.elementAt(n).GetValue() < obj.number.elementAt(n).GetValue())
					return false;
			}
				
		} else {
			if (comparison(obj) == -1)
				return true;
			if (comparison(obj) == 1)
				return false;
			for (int n = 0; n < number.size(); ++n){
				if (number.elementAt(n).GetValue() < obj.number.elementAt(n).GetValue())
					return true;
				if (number.elementAt(n).GetValue() > obj.number.elementAt(n).GetValue())
					return false;
			}
		}
		return false;
	}

	public boolean ge(bigNumber obj){
		if (sign == -1 && obj.sign == 1)
			return false;
		if (sign == 1 && obj.sign == -1)
			return true;
		if (sign == -1){
			if (comparison(obj) == -1)
				return true;
			if (comparison(obj) == 1)
				return false;
			for (int n = 0; n < number.size(); ++n){
				if (number.elementAt(n).GetValue() > obj.number.elementAt(n).GetValue())
					return false;
				if (number.elementAt(n).GetValue() < obj.number.elementAt(n).GetValue())
					return true;
			}
				
		} else {
			if (comparison(obj) == -1)
				return false;
			if (comparison(obj) == 1)
				return true;
			for (int n = 0; n < number.size(); ++n){
				if (number.elementAt(n).GetValue() < obj.number.elementAt(n).GetValue())
					return false;
				if (number.elementAt(n).GetValue() > obj.number.elementAt(n).GetValue())
					return true;
			}
		}		
		return false;
	}

	public boolean eq(bigNumber obj){
		if (sign == obj.sign)
			if (number.size() == obj.number.size()){
				for (int n = 0; n < number.size(); ++n)
					if (number.elementAt(n).GetValue() != obj.number.elementAt(n).GetValue())
						return false;
				return true;
			}
		return false;
	}

	public String toString(){
		StringBuffer temp = new StringBuffer(); 
		int count = number.size();
		if (sign < 0) temp.append('-');
		for(int i = 0; i < count; ++i){
			temp.append(number.elementAt(i).GetValue());
		}
		return temp.toString();
	}
}