package calc;

public class fraction{
	private bigNumber a;
	private bigNumber b;
	private int sign;
	public static fraction zer = new fraction(0,1);
	public static fraction one = new fraction(1,1);
	public static fraction two = new fraction(2,1);
	public static fraction round = new fraction(0,1);
	public static int proper = Const.PROPER;
	
	public fraction(){
		sign = 1;
		a = new bigNumber(0);
		b = new bigNumber(0);
		a.setABS();
		b.setABS();
	}
	public fraction(boolean x){
		if (x == true)
			a = new bigNumber(1);
		else 
			a = new bigNumber(0);
		b = new bigNumber(1);
		a.setABS();
		b.setABS();
		sign = 1;
	}
	public fraction(bigNumber x, bigNumber y){
		a = new bigNumber(x);
		b = new bigNumber(y);
		sign = 1;
		if (a.is_negative()) {
			sign = -1;
		}
		if (b.is_negative()) {
			sign *= -1;
			b.SetValue(b.un_minus());
			a.SetValue(a.un_minus());
		}
		a.setABS();
		b.setABS();
	}
	public fraction(fraction obj){
		a = new bigNumber(obj.a);
		b = new bigNumber(obj.b);
		sign = obj.sign;
	}
	public fraction(int x, int y){
		a = new bigNumber(x);
		b = new bigNumber(y);
		sign = 1;
		if (x < 0)
			sign = -1;
		if (y < 0)
			sign *= -1;
		a.setABS();
		b.setABS();
	}
	public bigNumber NOD(bigNumber A, bigNumber B){
		bigNumber HOD = new bigNumber(A.Ost(B));
		bigNumber Ost = new bigNumber(HOD);
		bigNumber DEL = new bigNumber();
		while (Ost.ge(bigNumber.zer) == true){
			A.SetValue(B);
			B.SetValue(Ost);
			HOD.SetValue(Ost);
			DEL.SetValue(A.Del(B));
			Ost.SetValue(A.Ost(B));
			if (DEL.eq(bigNumber.zer) == true) break;
		}
		if (HOD.ge(bigNumber.zer) == true)
			return HOD;
		else 
			return new bigNumber(0);
	}
	public void shorten(){
		/* A = B*(A/B) + HOD; */
		bigNumber A = new bigNumber(a);
		bigNumber B = new bigNumber(b);
		bigNumber HOD = new bigNumber(A.Ost(B));
		bigNumber Ost = new bigNumber(HOD);
		bigNumber DEL = new bigNumber();
		while (Ost.ge(bigNumber.zer)){
			A.SetValue(B);
			B.SetValue(Ost);
			HOD.SetValue(Ost);
			DEL.SetValue(A.Del(B));
			Ost.SetValue(A.Ost(B));
			if (DEL.eq(bigNumber.zer)) break;
		}
		if (HOD.ge(bigNumber.zer) && Ost.eq(bigNumber.zer)){	
			a.SetValue(a.Del(HOD));
			b.SetValue(b.Del(HOD));
		}
	}
	public String toString2(){
		StringBuffer result = new StringBuffer();
		if (sign == -1)
			result.append("-");
		int length = a.length() + b.length() + 1;
		char[] temp = new char[length + 1];
		int pos_temp = 0;
		int pos_big = 0;
		while (pos_big < a.length())
			temp[pos_temp++] = (char) (a.elementAt(pos_big++) + 48);
		temp[pos_temp++] = '_';
		pos_big = 0;
		while (pos_big < b.length())
			temp[pos_temp++] = (char) (b.elementAt(pos_big++) + 48);
		temp[pos_temp] = 0;
		result.append(temp);
		return result.toString();
	}
	public fraction integer(){
		fraction res = new fraction(0,1);
		if (a.le(b) == true)
			res.a.SetValue(bigNumber.zer);
		else 
			res.a.SetValue(a.Del(b));
		return res;
	}
	public fraction numerator(){
		fraction res = new fraction(this);
		res.b.SetValue(bigNumber.one);
		return res;
	}
	public fraction denominator(){
		fraction res = new fraction(this);
		res.a.SetValue(res.b);
		res.b.SetValue(bigNumber.one);
		return res;
	}
	public void set_den_ten(){
		if (b.eq(bigNumber.one) == true)
			b.set_power_of_ten(a.length());
	}
	public fraction SetValue(bigNumber obj){
		sign = obj.is_negative() ? -1 : 1;
		a.SetValue(obj);
		b.SetValue(bigNumber.one);
		return this;
	}
	public fraction SetValue(fraction obj){
		sign = obj.sign;
		a.SetValue(obj.a);
		b.SetValue(obj.b);
		return this;
	}
	public fraction SetValue(boolean x){
		sign = 1;
		if (x)
			a.SetValue(bigNumber.one);
		else
			a.SetValue(bigNumber.zer);
		b.SetValue(bigNumber.one);
		return this;
	}
	public fraction SetValue(int x){
		if (x >= 0){
			sign = 1;
			a.SetValue(new bigNumber(x));
		} else {
			sign = -1;
			a.SetValue(new bigNumber(-x));
		}
		b.SetValue(bigNumber.one);
		return this;
	}
	public fraction Add(fraction obj){
		fraction result = new fraction();
		result.a.SetValue(a.Mult(obj.b));
		result.b.SetValue(obj.a.Mult(b));
		result.a.SetValue(result.a.Add(result.b));
		result.b.SetValue(b.Mult(obj.b));
		result.sign = result.a.is_negative() ? -1 : 1;
		return result;
	}
	public fraction Minus(fraction obj){
		fraction result = new fraction();
		result.a.SetValue(a.Mult(obj.b));
		result.b.SetValue(obj.a.Mult(b));
		result.a.SetValue(result.a.minus(result.b));
		result.b.SetValue(b.Mult(obj.b));
		result.sign = result.a.is_negative() ? -1 : 1;
		return result;
	}
	public fraction Mult(fraction obj){
		fraction result = new fraction();
		result.a.SetValue(a.Mult(obj.a));
		result.b.SetValue(b.Mult(obj.b));
		result.sign = result.a.is_negative() ? -1 : 1;
		return result;
	}
	public fraction Del(fraction obj){
		fraction result = new fraction();
		result.a.SetValue(a.Mult(obj.b));
		result.b.SetValue(b.Mult(obj.a));
		if (result.b.is_negative()){
			result.b.SetValue(bigNumber.zer.minus(result.b));
			result.a.SetValue(bigNumber.zer.minus(result.a));
		}
		result.sign = result.a.is_negative() ? -1 : 1;
		return result;
	}
	public fraction power(fraction obj){
		if (obj.le(fraction.zer) == true){
			obj.sign = 0 - obj.sign;
			bigNumber x = new bigNumber(a);
			a.SetValue(b);
			b.SetValue(x);	
		}
		if (obj.a.eq(bigNumber.zer) == true)
			return new fraction(1,1);
		if (obj.a.eq(bigNumber.one) == true)
			return this;
		fraction summa = new fraction(1,1);
		fraction result = new fraction(0,1);	
		fraction stepE = new fraction(obj);
		fraction stepB = new fraction(1,1);
		while(stepB.le(stepE) == true){
			result.SetValue(this);
			//===================================//
			while (stepB.Mult(two).lt(stepE)){
				stepB.SetValue(stepB.Mult(two));
				result.SetValue(result.Mult(result));
			}
			summa.SetValue(summa.Mult(result));
			stepE.SetValue(stepE.Minus(stepB));
			stepB.SetValue(1);
			if (stepE.eq(one)){
				summa.SetValue(summa.Mult(this));
				break;
			}
		}
		return summa;
	}
	public boolean eq(fraction obj){
		if (sign != obj.sign) return false;
		if (!(a.eq(obj.a))) return false;
		if (!(b.eq(obj.b))) return false;
		return true;
	}
	public boolean ne(fraction obj){
		if (sign != obj.sign) return true;
		if (!(a.eq(obj.a))) return true;
		if (!(b.eq(obj.b))) return true;
		return false;
	}
	public boolean le(fraction obj){
		if (sign != obj.sign && obj.sign == -1) return false;
		bigNumber A = new bigNumber(a.Mult(obj.b));
		bigNumber B = new bigNumber(b.Mult(obj.a));
		return A.le(B);
	}
	public boolean ge(fraction obj){
		if (sign != obj.sign){
			if (sign == 1)
				return true;
			else
				return false;
		}
		bigNumber A = new bigNumber(a.Mult(obj.b));
		bigNumber B = new bigNumber(b.Mult(obj.a));
		return A.ge(B);
	}
	public boolean lt(fraction obj){
		if (sign != obj.sign && obj.sign == -1) return false;
		bigNumber A = new bigNumber(a.Mult(obj.b));
		bigNumber B = new bigNumber(b.Mult(obj.a));
		return A.le(B) || A.eq(B);
	}
	public boolean gt(fraction obj){
		if (sign != obj.sign && sign == -1) return false;
		bigNumber A = new bigNumber(a.Mult(obj.b));
		bigNumber B = new bigNumber(b.Mult(obj.a));
		return A.ge(B) || A.eq(B);
	}
	public boolean or(fraction obj){
		if (a.eq(bigNumber.zer) && obj.a.eq(bigNumber.zer))
			return false;
		return true;
	}
	public boolean and(fraction obj){
		if (!(a.eq(bigNumber.zer)) && !(obj.a.eq(bigNumber.zer)))
			return true;
		return false;
	}
	public fraction negation(){
		if (a.eq(bigNumber.zer))
			return new fraction(1,1);
		return new fraction(0,1);
	}
	public fraction un_minus(){
		fraction result = new fraction(this);
		result.sign *= -1;
		result.a.SetValue(result.a.un_minus());
		return result;
	}
	public String toString(){
		StringBuffer result = new StringBuffer();
		shorten();
		fraction temp = new fraction(this);
		if (sign == -1)
			result.append("-");
		boolean integer = (!((temp.b.eq(bigNumber.one)) || (temp.b.eq(bigNumber.zer))));
		boolean _null = false;
		int count = 0;
		if (fraction.proper == Const.ROUND){
			//    
			if (temp.a.ge(temp.b) && integer){
				bigNumber c = new bigNumber(temp.a.Del(temp.b));
				count = c.length();
				for(int i = 0; i < count; ++i)
					result.append((char) (c.elementAt(i)+48));
				c.SetValue(c.Mult(temp.b));
				temp.a.SetValue(temp.a.minus(c));		
			}
			result.append(".");
			bigNumber c = new bigNumber(temp.a.round(temp.a,temp.b, fraction.round.a));
			count = c.length();
				for(int i = 0; i < count; ++i)
					result.append((char) (c.elementAt(i)+48));
		} else {
			//    
			boolean point = false;
			if (proper == Const.PROPER && temp.a.ge(temp.b) && integer){
				//   
				bigNumber c = new bigNumber(temp.a.Del(temp.b));
				count = c.length();
				for(int i = 0; i < count; ++i)
					result.append((char) (c.elementAt(i)+48));
				c.SetValue(c.Mult(temp.b));
				temp.a.SetValue(temp.a.minus(c));
				point = true;
			}
			if (!(temp.a.eq(bigNumber.zer))){
				if (point)
					result.append(".");
				count = temp.a.length();
				for(int i = 0; i < count; ++i)
					result.append((char) (temp.a.elementAt(i)+48));
				if (integer){
					result.append("_");
					count = temp.b.length();
					for(int i = 0; i < count; ++i)
						result.append((char) (temp.b.elementAt(i)+48));
				}
			} else
				result.append('0');
		}	
		return result.toString();
	}	
}